//
//  Intro.swift
//  Post'TIM version swift
//
//  Créé par Alain Boudreault le 20105.11.15
//  Copyright (c) 2014 Alain Boudreault. All rights reserved.
//
//  MARK: - Note importante!
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

import UIKit

class Intro: UIViewController {
    
    @IBOutlet weak var titre1: UILabel!
    @IBOutlet weak var titre2: UILabel!

    @IBOutlet weak var logo: UIImageView!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        titre1.alpha = 0;
        titre2.alpha = 0;
        logo.alpha   = 0;
        logo.center.y = view.bounds.height  // Placer le centre du logo au bas de l'écran.
//      logo.center.y = view.frame.height   // Placer le centre du logo au bas de la view.
        
        // Voici le prototype de la méthode 'UIView.animateWithDuration'
        //  UIView.animateWithDuration(<#duration: NSTimeInterval#>, delay: <#NSTimeInterval#>, options: <#UIViewAnimationOptions#>, animations: <#() -> Void##() -> Void#>, completion: <#((Bool) -> Void)?##(Bool) -> Void#>)
        
        // Lancer une animation sur self.titre1.alpha
        // Rappel: Il faut toujours préciser le contexte des instances, dans un bloc. Par exemple, 'self.titre1'.
        let rotationComplete = CGFloat(M_PI * 2)
        UIView.animateWithDuration(1,
            delay: 0,
            options: UIViewAnimationOptions.CurveEaseIn,
            
            animations: {
                            self.titre1.alpha   = 1
                
                        },
            
            completion: { finished in
                            UIView.animateWithDuration( 2.0,
                                                        animations: {
                                                                        self.titre2.alpha = 1
                                                                        self.logo.alpha   = 1
                                                                        self.logo.center.y = self.titre2.center.y + self.titre2.frame.height
                                                                    },
                                                        completion: { finished in }
                            ) // UIView.animateWithDuration
                        } // completion:
 
        ) // UIView.animateWithDuration

        // Utilisation de GrandCentralDispatch (GCD) pour placer en attente un 'performSegueWithIdentifier'
        // Référence: http://www.raywenderlich.com/60749/grand-central-dispatch-in-depth-part-1
        let delaiEnSecondes:UInt64 = 2
        let delaiEnNanoSecondes = Int64(delaiEnSecondes * NSEC_PER_SEC)  // nanoSec = 10e-9 sec
        let deltaTemps = dispatch_time(DISPATCH_TIME_NOW, delaiEnNanoSecondes)
        dispatch_after(deltaTemps, dispatch_get_main_queue(),
            {
                self.performSegueWithIdentifier("versTaches", sender: self)
            }
        ) // dispatch_after
        
    }  // viewDidLoad()

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    } // didReceiveMemoryWarning()

} // class Intro: UIViewController
