//
//  VCAjouterTache.swift
//  Post'TIM version swift
//
//  Créé par Alain Boudreault le 20105.11.15
//  Copyright (c) 2014 Alain Boudreault. All rights reserved.
//
//  MARK: - Note importante!
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

import UIKit

// *********************************************************************************
// À compléter
// MARK: - ETAPE 2.1a - Programmer un protocole et la signature de ses méthodes
// ---------------------------------------------------------------------------------
protocol tacheDelegate {
    /**
        Retourne, au délégué du protocole tacheDelegate, la tâche à ajouter.
    
        :param: instance de la classe Tache
    */
    func ajouterTache(detailInfo:Tache)

    /**
        Retourne, au délégué du protocole tacheDelegate, la tâche modifiée.

        :param: instance de la classe Tache
    */
    func modifierTache(detailInfo:Tache)
} // protocol tacheDelegate
// *********************************************************************************


//MARK: - Définition de la classe VCAjouterTache

/**
    Classe permettant de présenter la scène Ajouter/Modifier Tâche.

    Le paramètre modeAjouter permet de déterminer si la scène présente une nouvelle tâche ou bien la tâche recue en paramètre.

    :returns: La tâche modifiée, en utilisant le protocole tacheDelegate.

    :param: modeAjouter = true, la view propose un tâche vide.

    :param: modeAjouter = false, la view propose la tâche qui a initiée le segue.

    :param: detailTache:Tache, une tâche à éditer.

    Projet: Post'TIM

    Auteur: Alain Boudreault

    Date:   2014.10.20
*/
class VCAjouterTache: UIViewController {

    // *********************************************************************************
    // MARK: - Les connexions MVC de la classe VCAjouterTache
    @IBOutlet weak var   titreAction:UILabel!
    @IBOutlet weak var   importance:UITextField!
    @IBOutlet weak var   tache:UITextField!
    @IBOutlet weak var   descriptionTache:UITextView!
    @IBOutlet weak var   leDatePicker:UIDatePicker!
    
    // *********************************************************************************
    // MARK: - Les propriétés de la classe VCAjouterTache
    /// La scène présente la tâche reçue si modeAjouter = false sinon elle présente une nouvelle tâche.
    var modeAjouter = false
    /// Propriété pour recevoir le détail d'une tâche.
    var detailTache:Tache!
    var info = Tache()      // Créer une tâche vide
    // *********************************************************************************
    
    // *********************************************************************************
    // À compléter
    // MARK: - ETAPE 2.1b - Définir une propriété pour recevoir l'adresse du délégué
    // ---------------------------------------------------------------------------------
    /// Le delégué du protocole tacheDelegate.
    var delegate:tacheDelegate?
    // ---------------------------------------------------------------------------------
    
    // *********************************************************************************
    // MARK: - Les @IBAction de la classe VCAjouterTache

    @IBAction func retourner(sender: AnyObject) {
        dismissViewControllerAnimated(true, completion: nil)
    } // retourner()

    @IBAction func sauvegarder(sender: AnyObject) {
        NSLog("sauvegarder: self.tache.text = %@", "self.tache.text");
        
        // Renseigner la tâche courante à partir des éléments d'interface
        info.date           = leDatePicker.date;
        info.description    = descriptionTache.text;
        info.tache          = tache.text;
        info.importance     = importance.text;
        // ***
        
        // *********************************************************************************
        // À compléter - Gérer le protocole
        // MARK: ETAPE 2.2 -  Si il y a un délégué alors lancer les méthodes du protocole:
        //              ajouterTache et modifierTache.
        // ---------------------------------------------------------------------------------
        // Si en modeAjouter
        if modeAjouter {
            delegate?.ajouterTache(info)
        }  // modeAjouter
 
        else // alors c'est 'modeModifier'
        {
            self.delegate?.modifierTache(info)
        }  // modeModifier
        // ---------------------------------------------------------------------------------
        
        dismissViewControllerAnimated(true, completion:nil)
    
    }  // sauvegarder
    
    // *********************************************************************************
    // MARK: - Les méthodes de la classe VCAjouterTache
    
    override func viewDidLoad() {
        super.viewDidLoad()
        println("VCAjouterTache:viewDidLoad: info = \(info)")
        if modeAjouter {
            titreAction.text = "Ajouter une tâche";
        } // if modeAjouter
        else  // Modifier la tâche
        {
            // Placer les données reçues à l'écran
            titreAction.text        = "Modifier la tâche";
            leDatePicker.date       = detailTache.date;
            descriptionTache.text   = detailTache.description;
            importance.text         = detailTache.importance;
            tache.text              = detailTache.tache;
        } // if modeModifier
    
    } // viewDidLoad()

    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    } // didReceiveMemoryWarning()
    

} // class VCAjouterTache
