//
//  VCDetail.swift
//  Post'TIM version swift
//
//  Créé par Alain Boudreault le 20105.11.15
//  Copyright (c) 2014 Alain Boudreault. All rights reserved.
//
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

import UIKit

/**
    Classe permettant de présenter la scène Détail Tâche.

    :returns: rien

    :param: detailTache:Tache, une tâche à afficher.

    Projet: Post'TIM

    Auteur: Alain Boudreault

    Date:   2014.10.20
*/
class VCDetail: UIViewController {

    @IBOutlet weak var tacheDate:UILabel!
    @IBOutlet weak var tacheTitre:UILabel!
    @IBOutlet weak var tacheImportance:UILabel!
    @IBOutlet weak var tacheDescription:UITextView!
    
    /// Propriété pour recevoir le détail d'une tâche.
    var detailTache:Tache!
    
    @IBAction func retourner(sender: AnyObject) {
        dismissViewControllerAnimated(true, completion: nil)
    } // retourner()

    override func viewDidLoad() {
        super.viewDidLoad()

        // Afficher les données reçues
        // Utilisation d'un 'DateFormatter' pour convertir en heure locale...
        // Voir documentation: // http://userguide.icu-project.org/formatparse/datetime
        let unFormateurDeDate = NSDateFormatter()
        unFormateurDeDate.dateFormat = "yyyy.MM.dd HH:mm"
        let dateMiseEnForme = unFormateurDeDate.stringFromDate(self.detailTache.date)
        self.tacheDate.text = dateMiseEnForme;
        self.tacheDescription.text = self.detailTache.description;
        self.tacheImportance.text = self.detailTache.importance;
        self.tacheTitre.text = self.detailTache.tache;
    }  // viewDidLoad()

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }  // didReceiveMemoryWarning()

}
