//
//  VCNotes.m
//  post'TIM
//
//  Created by Alain on 2013-11-06.
//  Copyright (c) 2013 Alain. All rights reserved.
//
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

// *********************************************************************************
// ETAPE 1.1 -  Analyser la structure du projet de départ
// ---------------------------------------------------------------------------------

// #### Les 'import's ##############################################################
#import "VCNotes.h"         // Classe courante
#import "VCAjouterTache.h"  // Utilisé pour passer la tâche courante lors du segue
#import "CelluleTache.h"    // Classe de la cellule du UITableView
#import "Tache.h"           // Classe perso pour une tâche
// #################################################################################

// ###### Souscrire à des protocoles par programmation #############################

// *********************************************************************************
// À compléter
// ETAPE 3.3 -  Indiquer que la classe courante doit souscrire au protocole de la
//              classe 'VCAjouterTache' ->  '<tacheDelegate>'
// ---------------------------------------------------------------------------------
@interface VCNotes () <tacheDelegate> // < ** ici ** >
@end
// #################################################################################

// ###### Les variables de la classe ###############################################
@implementation VCNotes{
    NSMutableArray *    tableauDesTaches;
    int                 indiceTacheCourante;
}
// #################################################################################


// #################################################################################
- (void)viewDidLoad
// #################################################################################
{
    [super viewDidLoad];
    [self copierPlistVersDocuments];
    [self lirePlist];
    //tableauDesTaches = [NSMutableArray arrayWithContentsOfFile:[[NSBundle mainBundle]pathForResource:@"listeDesTaches" ofType:@"plist"]];
    // NSLog(@"tableauDesTaches = %@", tableauDesTaches);
} // ### FIN -> viewDidLoad

// Note: Il est important de copier la version de départ de listeDesTaches.plist du bundle - qui est en lecture seule - vers le dossier document.
- (void) copierPlistVersDocuments {
    NSError *error;
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory =  [paths objectAtIndex:0];
    NSString *path = [documentsDirectory stringByAppendingPathComponent:@"listeDesTaches.plist"];
    NSFileManager *fileManager = [NSFileManager defaultManager];
    
    //check if the file exists already in users documents folder
    //if file does not exist copy it from the application bundle Plist file
    if ( ![fileManager fileExistsAtPath:path] ) {
        NSLog(@"Copie du fichier 'listeDesTaches.plist' vers le dossier documents");
        NSString *pathToSettingsInBundle = [[NSBundle mainBundle] pathForResource:@"listeDesTaches" ofType:@"plist"];
        [fileManager copyItemAtPath:pathToSettingsInBundle toPath:path error:&error];
    }
    //if file is already there do nothing
    else {
        NSLog(@"Le fichier 'listeDesTaches.plist' est déjà dans le dossier documents");
    }
}


- (void) lirePlist {
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory =  [paths objectAtIndex:0];
    NSString *plistPath = [documentsDirectory stringByAppendingPathComponent:@"listeDesTaches.plist"];
    tableauDesTaches = [[[NSMutableArray alloc] initWithContentsOfFile:plistPath]mutableCopy];
    NSLog(@"%@", tableauDesTaches);
}

- (void) updatePlist {
    //NSMutableArray *tempArray = [[NSMutableArray alloc] init];
   /*
    for (NSDictionary *object in mountainsArray) {
        if ([[object objectForKey:@"Number"] isEqualToString:@"1"]) {
            [tempArray insertObject:object atIndex:0];
        }
    }
    */
    //NSMutableDictionary *dict = [tempArray objectAtIndex:0];
    //[dict setObject:@"" forKey:@"Climbed"];
    //[mountainsArray replaceObjectAtIndex:0 withObject:dict];
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory =  [paths objectAtIndex:0];
    NSLog(@"documentsDirectory = %@", documentsDirectory);
    NSString *path = [documentsDirectory stringByAppendingPathComponent:@"listeDesTaches.plist"];
    NSLog(@"path = %@", path);

    [tableauDesTaches writeToFile:path atomically:YES];
}

#pragma mark - Table view data source

// *********************************************************************************
// À compléter
// ETAPE 1.2 -  Ajouter la méthode 'commitEditingStyle'
//              Actualiser le tableau des tâches
//              Actualiser le UITableView
//              Enregistrer le tableau des tâches dans 'listeDesTaches.plist'
// ---------------------------------------------------------------------------------
// Méthode de délégation pour gérer la suppression de la cellule sur swap
// #################################################################################
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
// #################################################################################
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Effacer, de tableauDesTaches,
        // l'élément correspondant à la cellule courante
        [tableauDesTaches removeObjectAtIndex:indexPath.row];

        // Enregistrer le tableau dans le fichier.plist
        // atomically:YES = enregistrer dans une copie avant de remplacer le fichier original.
        //[tableauDesTaches writeToFile:[[NSBundle mainBundle] pathForResource:@"listeDesTaches" ofType:@"plist" ]atomically:YES];
        [self updatePlist];
        // Actualiser le UITableView
        [self.tableView reloadData];
    } // FIN -> editingStyle == delete
    
} // ### FIN -> commitEditingStyle
// ---------------------------------------------------------------------------------


// #################################################################################
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
// #################################################################################
{
    return tableauDesTaches.count;
} // ### FIN -> numberOfRowsInSection


// #################################################################################
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
// #################################################################################
{
    static NSString *CellIdentifier = @"Cell";
    Tache * tacheCourante = [[Tache alloc]initWithTache:tableauDesTaches[indexPath.row]];
    CelluleTache *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    // Renseigner les éléments de la cellule courante
    cell.tache.text = tacheCourante.tache;

    // Utilisation d'un 'DateFormatter' pour convertir en heure locale...
    // Voir documentation: // http://userguide.icu-project.org/formatparse/datetime
    // *********************************************************************************
    // À compléter
    // ETAPE 1.3 - Utiliser un NSDateFormatter pour convertir en format local
    // ---------------------------------------------------------------------------------
    NSDateFormatter *unFormateurDeDate = [[NSDateFormatter alloc] init];
    [unFormateurDeDate setDateFormat:@"yyyy.MM.dd HH:mm"];
    NSString *dateMiseEnForme = [unFormateurDeDate stringFromDate:tacheCourante.date];
    cell.date.text = dateMiseEnForme;
    // ---------------------------------------------------------------------------------
    
    // cell.date.text = tacheCourante.date.description;
    cell.importance.text = tacheCourante.importance;

    return cell;
} // ### FIN -> cellForRowAtIndexPath

#pragma mark - Préparation du segue
// #################################################################################
-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
// #################################################################################
{
    VCAjouterTache * vers = [segue destinationViewController];

    // *********************************************************************************
    // À compléter
    // ETAPE 1.4 - Déterminer la cellule du sender
    // ---------------------------------------------------------------------------------
    // Note sender == UIButton et non pas UITableViewCell
    // Donc, voici comment obtenir la position du UITableViewCell:
    UIButton *button = (UIButton *)sender;
    CGRect buttonFrame = [button convertRect:button.bounds toView:self.tableView];
    NSIndexPath *indexPath = [self.tableView indexPathForRowAtPoint:buttonFrame.origin];
    // ---------------------------------------------------------------------------------
    
    // *********************************************************************************
    // À compléter
    // ETAPE 1.5 -  Déterminer la destination du segue.
    //           -  Préparer les données en fn de la destination
    // ---------------------------------------------------------------------------------

    // Tester si 'segue' est = 'ajouter'
    if ([segue.identifier isEqual:@"ajouter"]){
        // *********************************************************************************
        // À compléter
        // ETAPE 3.4b - Renseigner le délégué
        // ---------------------------------------------------------------------------------
        vers.delegate = self;
        // ---------------------------------------------------------------------------------
        vers.modeAjouter = YES;
        NSLog(@"Transition vers %@", segue.identifier);
    }

    // Tester si 'segue' est = 'modifier'
    if ([segue.identifier isEqual:@"modifier"]){
        // *********************************************************************************
        // À compléter
        // ETAPE 3.5b - Renseigner le délégué
        // ---------------------------------------------------------------------------------
        vers.delegate = self;
        // ---------------------------------------------------------------------------------

        vers.modeAjouter = NO;
        vers.detailTache = [[Tache alloc]initWithTache: tableauDesTaches[indexPath.row]];
        // sauvegarder la sélection courante pour le retour de modifierTache
        indiceTacheCourante = indexPath.row;
        NSLog(@"Transition vers %@ avec indice: %d", segue.identifier, indexPath.row);
    }
    
    // Tester si 'segue' est = 'detail'
    if ([segue.identifier isEqual:@"detail"]){
        vers.detailTache = [[Tache alloc]initWithTache: tableauDesTaches[indexPath.row]];
        NSLog(@"Transition vers %@ avec indice: %d", segue.identifier, indexPath.row);
    }
    // ---------------------------------------------------------------------------------
    
} // ### FIN -> prepareForSegue

#pragma mark - programmer la delegation de la classe 'VCAjouterTache'
// *********************************************************************************
// À compléter
// ETAPE 3.4a - Programmer la méthode de délégation 'ajouterTache'
// ---------------------------------------------------------------------------------
-(void) ajouterTache:(Tache*)info{
    NSLog(@"délégation - ajouterTache, info = %@", info.tache);

    // Ajouter au tableauTaches les données reçues.
    [tableauDesTaches addObject:[info tacheToDictionary]];
    NSLog(@"tableauDesTaches ajouterTache = %@", [info tacheToDictionary]);

    // Actualiser le UITableView
    [self.tableView reloadData];

    // Enregistrer tableauTaches dans le fichier 'listeDesTaches.plist'
    // atomically:YES = enregistrer dans une copie avant de remplacer le fichier original.
    //[tableauDesTaches writeToFile:[[NSBundle mainBundle] pathForResource:@"listeDesTaches" ofType:@"plist" ]atomically:YES];
    [self updatePlist];
} // ### FIN -> ajouterTache
// ---------------------------------------------------------------------------------

// *********************************************************************************
// À compléter
// ETAPE 3.5a - Programmer la méthode de délégation 'ModifierTache'
// ---------------------------------------------------------------------------------
-(void) modifierTache:(Tache*)info{
    NSLog(@"retour de la méthode 'modifier', info = %@", info);

    // Remplacer l'élément courant du tableauTaches par les données reçues.
    tableauDesTaches[indiceTacheCourante] = [info tacheToDictionary];
    NSLog(@"tableauDesTaches élément %d modifié = %@", indiceTacheCourante, tableauDesTaches);

    // Actualiser le UITableView
    [self.tableView reloadData];

    // Enregistrer tableauTaches dans le fichier 'listeDesTaches.plist'
    //[tableauDesTaches writeToFile:[[NSBundle mainBundle] pathForResource:@"listeDesTaches" ofType:@"plist" ]atomically:YES];
    [self updatePlist];
} // ### FIN -> modifierTache
// ---------------------------------------------------------------------------------

@end
